package com.mobai.webMagic;

import org.apache.log4j.Logger;
import us.codecraft.webmagic.Page;
import us.codecraft.webmagic.Site;
import us.codecraft.webmagic.Spider;
import us.codecraft.webmagic.pipeline.JsonFilePipeline;
import us.codecraft.webmagic.processor.PageProcessor;
import us.codecraft.webmagic.selector.Selectable;

import java.util.List;

public class OschinaBlogPageProcessor implements PageProcessor {

    private static final Logger log = Logger.getLogger(OschinaBlogPageProcessor.class);
    //    private Site site = Site.me().setDomain("my.oschina.net");
    private Site site = Site.me().setRetryTimes(3)
//            .setSleepTime(24*60*60*1000);
            .setSleepTime(1000);

    @Override
    public void process(Page page) {
        // http://www.nanshan.edu.cn/info/1051/8951.htm
        // http://www.nanshan.edu.cn/nyyw.htm
        // http://www.nanshan.edu.cn/nyyw/123.htm
        Selectable url1 = page.getUrl();
//        Selectable xpath = page.getUrl().xpath("http://www.nanshan.edu.cn/nyyw.123.*");
        page.getRequest().getUrl();
//        if (!url1.match()) {
        if (url1 == null) {
            log.error("url为空");
            return;
        }
        log.info(url1.get());
        if (("http://www.nanshan.edu.cn/nyyw.*").matches(url1.get())) {
            // 获取烟台南山学院的新闻Url
            List<String> newsUrls = page.getHtml()
                    .xpath("/html/body/div[5]/div[1]/div[1]/div[2]/div/ul/li/a").links().all();
            // 存在分页,将下一页url 添加到待采集列表
            String nextPage = page.getHtml().xpath("/html/body/div[5]/div[1]/div[1]/div[5]/div/div[2]/div/table/tbody/tr/table/tr/td[2]/div/a[2]").links().get();
            newsUrls.add(nextPage);
            // 添加
            page.addTargetRequests(newsUrls);
        } else {
            String url = page.getUrl().toString();
            String title = page.getHtml().xpath("/html/body/div[5]/div[1]/div[1]/div[2]/form/div/h1/text()").get();
            // 日期等信息需分割 包括  来源
            String newsHead = page.getHtml().xpath("/html/body/div[5]/div[1]/div[1]/div[2]/form/div/div[1]/text()").get();
            String[] split = newsHead.split("：");
            String date = newsHead.substring(newsHead.indexOf(split[2]), newsHead.indexOf(split[2]) + 10);
            String source  = newsHead.substring(newsHead.indexOf(split[5]), newsHead.indexOf(split[5]) + 7);
            String content = page.getHtml().xpath("/html/body/div[5]/div[1]/div[1]/div[2]/form/div/div[2]/allText()").get();
            page.putField("url", url);
            page.putField("title", title);
            page.putField("date", date);
            page.putField("source", source);
            page.putField("content", content);
        }
        List<String> links = page.getHtml().links().regex("http://my\\.oschina\\.net/flashsword/blog/\\d+").all();
        page.addTargetRequests(links);
        System.out.println("页面提取执行完毕");

    }

    @Override
    public Site getSite() {
        return site;

    }

    public static void main(String[] args) {
        Spider.create(new OschinaBlogPageProcessor())
                .addUrl("http://www.nanshan.edu.cn/info/1051/8981.htm")
                .addPipeline(new JsonFilePipeline("news/"))
                .run();
    }
}